diff -Nur -Xfreecivdiff.ignore freeciv-cvs/common/city.c freeciv-patched/common/city.c
--- freeciv-cvs/common/city.c	2003-06-30 12:18:29.000000000 +0100
+++ freeciv-patched/common/city.c	2003-06-30 12:18:17.000000000 +0100
@@ -41,8 +41,7 @@
 static void citizen_happy_size(struct city *pcity);
 static void citizen_happy_luxury(struct city *pcity);
 static void citizen_happy_units(struct city *pcity, int unhap);
-static void citizen_happy_buildings(struct city *pcity);
-static void citizen_happy_wonders(struct city *pcity);
+static void citizen_happy_buildings(struct city *pcity, int wonder);
 static void unhappy_city_check(struct city *pcity);
 static void set_pollution(struct city *pcity);
 static void set_food_trade_shields(struct city *pcity);
@@ -223,10 +222,10 @@
 	&& city_affected_by_wonder(pcity, B_MICHELANGELO))
       return TRUE;
     break;
-  case B_CITY:  
+/*case B_CITY:  
     if (city_affected_by_wonder(pcity, B_WALL))
       return TRUE;
-    break;
+    break;*/
   case B_HYDRO:
   case B_POWER:
   case B_NUCLEAR:
@@ -287,12 +286,12 @@
   int build=pcity->shield_stock;
 
   if (pcity->is_building_unit) {
-    total=unit_value(pcity->currently_building);
+    total = unit_value_adjusted(pcity->currently_building, pcity);
     if (build>=total)
       return 0;
     cost=(total-build)*2+(total-build)*(total-build)/20; 
   } else {
-    total=improvement_value(pcity->currently_building);
+    total = improvement_value_adjusted(pcity->currently_building, pcity);
     if (build>=total)
       return 0;
     cost=(total-build)*2;
@@ -343,6 +342,21 @@
 }
 
 /**************************************************************************
+  Is the given improvement a space ship component?
+**************************************************************************/
+static bool is_space_part(Impr_Type_id id)
+{
+  struct impr_effect *eff;
+
+  for (eff = get_improvement_type(id)->effect;
+       eff && eff->type != EFT_LAST; eff++) {
+    if (eff->type == EFT_SPACE_PART)
+      return TRUE;
+  }
+  return FALSE;
+}
+
+/**************************************************************************
  Will this city ever be able to build this improvement?
  Doesn't check for building prereqs
 **************************************************************************/
@@ -352,6 +366,10 @@
   if (!could_player_eventually_build_improvement(city_owner(pcity),id))
     return FALSE;
 
+  if (!(pcity->buildflags & CITY_ENABLE_SPACE)
+      && is_space_part(id))
+    return FALSE;
+
   if (city_got_building(pcity, id))
     return FALSE;
 
@@ -416,6 +434,11 @@
     return FALSE;
   }
 
+  if (unit_type_flag(id, F_NUCLEAR)
+      && !(pcity->buildflags & CITY_ENABLE_NUKE)) {
+    return FALSE;
+  }
+
   /* You can't build naval units inland. */
   if (!is_ocean_near_tile(pcity->x, pcity->y) && is_water_unit(id)) {
     return FALSE;
@@ -486,9 +509,7 @@
     return 0;
   if (is_wonder(i))
     return 0;
-  if (improvement_types[i].upkeep == 1 &&
-      city_affected_by_wonder(pcity, B_ASMITHS)) 
-    return 0;
+  if (improvement_types[i].upkeep <= pcity->upkeep_free) return 0;
   if (government_has_flag(get_gov_pcity(pcity), G_CONVERT_TITHES_TO_MONEY)
       && (i == B_TEMPLE || i == B_COLOSSEUM || i == B_CATHEDRAL)) {
     return 0;
@@ -498,7 +519,8 @@
 }
 
 /**************************************************************************
-  Caller to pass asmiths = city_affected_by_wonder(pcity, B_ASMITHS)
+  Caller to pass asmiths = TRUE if we should honour the upkeep_free field
+  in pcity (set by improvements such as A.Smith's)
 **************************************************************************/
 static int improvement_upkeep_asmiths(struct city *pcity, Impr_Type_id i,
 				      bool asmiths)
@@ -507,7 +529,7 @@
     return 0;
   if (is_wonder(i))
     return 0;
-  if (asmiths && improvement_types[i].upkeep == 1) 
+  if (asmiths && improvement_types[i].upkeep <= pcity->upkeep_free)
     return 0;
   if (government_has_flag(get_gov_pcity(pcity), G_CONVERT_TITHES_TO_MONEY)
       && (i == B_TEMPLE || i == B_COLOSSEUM || i == B_CATHEDRAL)) {
@@ -583,11 +605,14 @@
   }
   if (contains_special(spec_t, S_RAILROAD))
     s+=(s*terrain_control.rail_shield_bonus)/100;
-  if (city_affected_by_wonder(pcity, B_RICHARDS))
-    s++;
-  if (is_ocean(tile_t) && city_got_building(pcity, B_OFFSHORE)) {
-    s++;
+
+  /* Add effects from generalised improvements */
+  s += pcity->tile_bonuses[x][y].shields;
+  if (s > 0) {
+    s += pcity->tile_add[x][y].shields;
   }
+  s = s * pcity->tile_pct[x][y].shields / 100;
+
   /* government shield bonus & penalty */
   if (s > 0)
     s += (is_celebrating ? g->celeb_shield_bonus : g->shield_bonus);
@@ -677,6 +702,15 @@
   if (contains_special(spec_t, S_ROAD)) {
     t += (get_tile_type(tile_t))->road_trade_incr;
   }
+
+  /* Add effects from generalised improvements */
+  t += pcity->tile_bonuses[x][y].trade;
+  if (t > 0) {
+    t += pcity->tile_add[x][y].trade;
+  }
+  if (t < 0) t = 0;  /* Don't want tiles producing negative trade */
+  t = t * pcity->tile_pct[x][y].trade / 100;
+
   if (t > 0) {
     int before_penalty = (is_celebrating ? g->celeb_trade_before_penalty
 			  : g->trade_before_penalty);
@@ -689,11 +723,6 @@
     if (t > 0)
       t += (is_celebrating ? g->celeb_trade_bonus : g->trade_bonus);
 
-    if(city_affected_by_wonder(pcity, B_COLLOSSUS)) 
-      t++;
-    if(contains_special(spec_t, S_ROAD) && city_got_building(pcity, B_SUPERHIGHWAYS))
-      t+=(t*terrain_control.road_superhighway_trade_bonus)/100;
- 
     /* government trade penalty -- SKi */
     if (before_penalty > 0 && t > before_penalty) 
       t--;
@@ -788,17 +817,14 @@
 
   if (contains_special(spec_t, S_IRRIGATION) || city_auto_water) {
     f += type->irrigation_food_incr;
-    if ((contains_special(spec_t, S_FARMLAND) ||
-	 (city_auto_water &&
-	  player_knows_techs_with_flag(city_owner(pcity), TF_FARMLAND))) &&
-	city_got_building(pcity, B_SUPERMARKET)) {
-      f += (f * terrain_control.farmland_supermarket_food_bonus) / 100;
-    }
   }
 
-  if (is_ocean(tile_t) && city_got_building(pcity, B_HARBOUR)) {
-    f++;
+  /* Add effects from generalised improvements */
+  f += pcity->tile_bonuses[x][y].food;
+  if (f > 0) {
+    f += pcity->tile_add[x][y].food;
   }
+  f = f * pcity->tile_pct[x][y].food / 100;
 
   if (contains_special(spec_t, S_RAILROAD))
     f+=(f*terrain_control.rail_food_bonus)/100;
@@ -910,11 +936,10 @@
 *************************************************************************/
 int city_gold_surplus(struct city *pcity)
 {
-  bool asmiths = city_affected_by_wonder(pcity, B_ASMITHS);
   int cost=0;
 
   built_impr_iterate(pcity, i) {
-    cost += improvement_upkeep_asmiths(pcity, i, asmiths);
+    cost += improvement_upkeep_asmiths(pcity, i, TRUE);
   } built_impr_iterate_end;
 
   return pcity->tax_total-cost;
@@ -1257,8 +1282,13 @@
   int city_shield_surplus = pcity->shield_surplus;
   int city_shield_stock = include_shield_stock ?
       city_change_production_penalty(pcity, id, id_is_unit, FALSE) : 0;
-  int improvement_cost = id_is_unit ?
-    get_unit_type(id)->build_cost : get_improvement_type(id)->build_cost;
+  int improvement_cost;
+
+  if (id_is_unit) {
+    improvement_cost = unit_value_adjusted(id, pcity);
+  } else {
+    improvement_cost = improvement_value_adjusted(id, pcity);
+  }
 
   if (include_shield_stock && (city_shield_stock >= improvement_cost)) {
     return 1;
@@ -1422,23 +1452,7 @@
 **************************************************************************/
 int get_city_shield_bonus(struct city *pcity)
 {
-  int shield_bonus = 100;
-
-  if (city_got_building(pcity, B_FACTORY)) {
-    shield_bonus += 50;
-    if (city_got_building(pcity, B_MFG)) {
-      shield_bonus += 50;
-    }
-
-    if (city_affected_by_wonder(pcity, B_HOOVER) ||
-	city_got_building(pcity, B_POWER) ||
-	city_got_building(pcity, B_HYDRO) ||
-	city_got_building(pcity, B_NUCLEAR)) {
-      shield_bonus = 100 + (3 * (shield_bonus - 100)) / 2;
-    }
-  }
-
-  return shield_bonus;
+  return pcity->shield_bonus;
 }
 
 /**************************************************************************
@@ -1447,19 +1461,7 @@
 **************************************************************************/
 int get_city_tax_bonus(struct city *pcity)
 {
-  int tax_bonus = 100;
-
-  if (city_got_building(pcity, B_MARKETPLACE)) {
-    tax_bonus += 50;
-    if (city_got_building(pcity, B_BANK)) {
-      tax_bonus += 50;
-      if (city_got_building(pcity, B_STOCK)) {
-	tax_bonus += 50;
-      }
-    }
-  }
-
-  return tax_bonus;
+  return pcity->tax_bonus;
 }
 
 /**************************************************************************
@@ -1467,25 +1469,7 @@
 **************************************************************************/
 static int get_city_tithes_bonus(struct city *pcity)
 {
-  int tithes_bonus = 0;
-
-  if (!government_has_flag
-      (get_gov_pcity(pcity), G_CONVERT_TITHES_TO_MONEY)) {
-    return 0;
-  }
-
-  if (city_got_building(pcity, B_TEMPLE))
-    tithes_bonus += get_temple_power(pcity);
-  if (city_got_building(pcity, B_COLOSSEUM))
-    tithes_bonus += get_colosseum_power(pcity);
-  if (city_got_effect(pcity, B_CATHEDRAL))
-    tithes_bonus += get_cathedral_power(pcity);
-  if (city_affected_by_wonder(pcity, B_BACH))
-    tithes_bonus += 2;
-  if (city_affected_by_wonder(pcity, B_CURE))
-    tithes_bonus += 1;
-
-  return tithes_bonus;
+  return pcity->tithes_bonus;
 }
 
 /**************************************************************************
@@ -1493,28 +1477,7 @@
 **************************************************************************/
 int get_city_science_bonus(struct city *pcity)
 {
-  int science_bonus = 100;
-
-  if (city_got_building(pcity, B_LIBRARY)) {
-    science_bonus += 50;
-    if (city_got_building(pcity, B_UNIVERSITY)) {
-      science_bonus += 50;
-    }
-    if (city_got_effect(pcity, B_RESEARCH)) {
-      science_bonus += 50;
-    }
-  }
-  if (city_affected_by_wonder(pcity, B_COPERNICUS)) {
-    science_bonus += 50;
-  }
-  if (city_affected_by_wonder(pcity, B_ISAAC)) {
-    science_bonus += 100;
-  }
-  if (government_has_flag(get_gov_pcity(pcity), G_REDUCED_RESEARCH)) {
-    science_bonus /= 2;
-  }
-
-  return science_bonus;
+  return pcity->science_bonus;
 }
 
 /**************************************************************************
@@ -1642,11 +1605,6 @@
 **************************************************************************/
 static void add_buildings_effect(struct city *pcity)
 {
-  /* this is the place to set them */
-  pcity->tax_bonus = get_city_tax_bonus(pcity);
-  pcity->science_bonus = get_city_science_bonus(pcity);
-  pcity->shield_bonus = get_city_shield_bonus(pcity);
-
   pcity->shield_prod = (pcity->shield_prod * pcity->shield_bonus) / 100;
   pcity->luxury_total = (pcity->luxury_total * pcity->tax_bonus) / 100;
   pcity->tax_total = (pcity->tax_total * pcity->tax_bonus) / 100;
@@ -1655,6 +1613,386 @@
 }
 
 /**************************************************************************
+  Sets the given city's shield/food/trade per-tile bonuses to defaults
+**************************************************************************/
+void city_init_tile_mods(struct city *pcity)
+{
+  struct tile_mod *tilept;
+
+  city_map_iterate(x, y) {
+    tilept = &pcity->tile_bonuses[x][y];
+    tilept->trade = tilept->shields = tilept->food = 0;
+
+    tilept = &pcity->tile_add[x][y];
+    tilept->trade = tilept->shields = tilept->food = 0;
+
+    tilept = &pcity->tile_pct[x][y];
+    tilept->trade = tilept->shields = tilept->food = 100;
+  } city_map_iterate_end;
+}
+
+static int handle_tile_bonuses(
+               struct impr_effect *imeff,
+               struct tile_mod add[CITY_MAP_SIZE][CITY_MAP_SIZE],
+               struct tile_mod bonus[CITY_MAP_SIZE][CITY_MAP_SIZE],
+               struct tile_mod pct[CITY_MAP_SIZE][CITY_MAP_SIZE],
+               enum tile_special_type tile_spec[CITY_MAP_SIZE][CITY_MAP_SIZE],
+               enum tile_terrain_type tile_terr[CITY_MAP_SIZE][CITY_MAP_SIZE])
+{
+  int amount;
+
+  amount = imeff->amount;
+
+  switch(imeff->type) {
+  case EFT_TRADE_ADD_TILE:
+  case EFT_TRADE_INC_TILE:
+  case EFT_TRADE_PER_TILE:
+  case EFT_PROD_ADD_TILE:
+  case EFT_PROD_INC_TILE:
+  case EFT_PROD_PER_TILE:
+  case EFT_FOOD_ADD_TILE:
+  case EFT_FOOD_INC_TILE:
+  case EFT_FOOD_PER_TILE:
+    city_map_iterate(x, y) {
+      if (is_unit_terrain_affected(imeff, NULL, tile_terr[x][y],
+                                   tile_spec[x][y])) {
+        switch(imeff->type) {
+        case EFT_TRADE_ADD_TILE:
+          add[x][y].trade += amount; break;
+        case EFT_TRADE_INC_TILE:
+          bonus[x][y].trade += amount; break;
+        case EFT_TRADE_PER_TILE:
+          pct[x][y].trade = pct[x][y].trade * amount / 100; break;
+        case EFT_PROD_ADD_TILE:
+          add[x][y].shields += amount; break;
+        case EFT_PROD_INC_TILE:
+          bonus[x][y].shields += amount; break;
+        case EFT_PROD_PER_TILE:
+          pct[x][y].shields = pct[x][y].shields * amount / 100; break;
+        case EFT_FOOD_ADD_TILE:
+          add[x][y].food += amount; break;
+        case EFT_FOOD_INC_TILE:
+          bonus[x][y].food += amount; break;
+        case EFT_FOOD_PER_TILE:
+          pct[x][y].food = pct[x][y].food * amount / 100; break;
+        default:
+          break;
+        }
+      }
+    } city_map_iterate_end;
+    return TRUE;
+  default:
+    return FALSE;
+  }
+}
+
+/**************************************************************************
+  Sets the maximum size that the city can grow (-1 = no limit) and, if
+  applicable, the improvement needed to increase this limit
+**************************************************************************/
+static void set_city_size_limit(struct city *pcity, int size_unlimit)
+{
+  int impr, unlimit_impr = B_LAST, size_limit = -1;
+  struct impr_effect *imeff;
+
+  /* May be better to run this loop after reading rulesets, and store the
+   * unlimit effects, rather than running this every time - check profiles */
+  for (impr = 0; impr < game.num_impr_types; impr++) {
+    for (imeff = improvement_types[impr].effect;
+         imeff && imeff->type != EFT_LAST; imeff++) {
+      if (imeff->type == EFT_SIZE_UNLIMIT && imeff->amount > size_unlimit
+          && (size_limit == -1 || size_limit >= imeff->amount)) {
+        size_limit = imeff->amount;
+        unlimit_impr = impr;
+      }
+    }
+  }
+
+  pcity->size_limit = size_limit;
+  pcity->unlimit_impr = unlimit_impr;
+}
+
+static void update_bonus(int bonus[4], int amount, struct eff_iter *iter,
+    			 bool add_bonus)
+{
+  int bonusind = 0;
+
+  if (iter->imeff->outside) {
+    switch(iter->range) {
+    case EFR_ISLAND:
+      bonusind = 1;
+      break;
+    case EFR_PLAYER:
+      bonusind = 2;
+      break;
+    case EFR_WORLD:
+      bonusind = 3;
+      break;
+    default:
+      break;
+    }
+  }
+  if (add_bonus) {
+    bonus[bonusind] += amount;
+  } else {
+    bonus[bonusind] = bonus[bonusind] * amount / 100;
+  }
+}
+
+/**************************************************************************
+  Updates the various modifiers and bonuses due to city improvements
+  (should be called whenever city effects change - i.e. by
+  update_all_effects and friends)
+**************************************************************************/
+void update_city_bonuses(struct city *pcity)
+{
+  int tax_bonus[4] = { 100, 100, 100, 100 };
+  int science_bonus[4] = { 100, 100, 100, 100 };
+  int shield_bonus = 100, luxury_bonus = 100; /* City bonuses */
+  int tax_pct[4] = { 100, 100, 100, 100 };
+  int science_pct[4] = { 100, 100, 100, 100 };
+  int shield_pct = 100, luxury_pct = 100;     /* City bonus multipliers */
+  int poppoladj = 100, prodpoladj = 100,      /* Pollution adjustments */
+      poladj = 100;
+  int poppolpct = 100, prodpolpct = 100,      /* Pollution multipliers */
+      polpct = 100;
+  int makecontent = 0, makehappy = 0,         /* Happiness modifiers */
+      forcecontent = 0, forcehappy = 0;
+  int defensepct[UCL_LAST + 1];               /* Defense multipliers */
+  int attackpct[UCL_LAST + 1];                /* Attack multipliers */
+  int defensefppct[UCL_LAST + 1];             /* Firepower multipliers */
+  int attackfppct[UCL_LAST + 1];
+  int impr_cost_adj;			      /* Cost modifiers */
+  int unit_cost_adj[UCL_LAST + 1];
+  int impr_cost_pct;			      /* Cost multipliers */
+  int unit_cost_pct[UCL_LAST + 1];
+  int makecontentpct = 100, forcecontentpct = 100;
+  int makecontentmil = 0, makecontentmilper = 0;
+  int corruptadj = 0, corruptpct = 100;
+  int size_unlimit = -1, upkeep_free = 0;
+  enum city_flags buildflags = 0;
+  int growth_food = 0, nuke_proof = 0;
+
+  enum tile_special_type spec = map_get_special(pcity->x, pcity->y);
+  enum tile_terrain_type terr = map_get_terrain(pcity->x, pcity->y);
+  enum tile_special_type tile_spec[CITY_MAP_SIZE][CITY_MAP_SIZE];
+  enum tile_terrain_type tile_terr[CITY_MAP_SIZE][CITY_MAP_SIZE];
+
+  int amount, i;
+  struct player *pplayer;
+  struct government *gov;
+
+  pplayer = city_owner(pcity);
+  gov = get_gov_pcity(pcity);
+
+  impr_cost_pct = impr_cost_adj = 100;
+  for (i = 0; i <= UCL_LAST; i++) {
+    defensepct[i] = attackpct[i] = defensefppct[i] = attackfppct[i] = 100;
+    unit_cost_pct[i] = unit_cost_adj[i] = 100;
+  }
+
+  city_init_tile_mods(pcity);
+  pcity->airlift = FALSE;
+
+  city_map_iterate(x, y) {
+    struct tile_type *type;
+    int map_x, map_y, is_real, city_auto_water;
+
+    is_real = city_map_to_map(&map_x, &map_y, pcity, x, y);
+    if (is_real) {
+      tile_spec[x][y] = map_get_special(map_x, map_y);
+      tile_terr[x][y] = map_get_terrain(map_x, map_y);
+    } else {
+      tile_spec[x][y] = S_ALL;
+      tile_terr[x][y] = T_UNKNOWN;
+    }
+
+    type = get_tile_type(tile_terr[x][y]);
+    city_auto_water = (is_city_center(x, y)
+                       && tile_terr[x][y] == type->irrigation_result
+                       && terrain_control.may_irrigate);
+    /* City centre counts as farmland if we have the necessary tech */
+    if (city_auto_water
+        && player_knows_techs_with_flag(city_owner(pcity), TF_FARMLAND)) {
+      tile_spec[x][y] |= S_FARMLAND;
+    }
+  } city_map_iterate_end;
+
+  /* Ignore terrain in the iteration, as it's the terrain of the city
+     center - we need to consider all city tiles too */
+  city_effects_iterate_full(iter, pcity, NULL, T_UNKNOWN, S_ALL) {
+    if (!handle_tile_bonuses(iter.imeff, pcity->tile_add,
+                             pcity->tile_bonuses, pcity->tile_pct,
+                             tile_spec, tile_terr)
+        && is_unit_terrain_affected(iter.imeff, NULL, terr, spec)) {
+      amount = iter.imeff->amount;
+      switch(iter.imeff->type) {
+      case EFT_UNIT_DEFEND:
+	defensepct[iter.imeff->aff_unit] = defensepct[iter.imeff->aff_unit]
+	  				   * amount / 100;
+	break;
+      case EFT_UNIT_ATTACK:
+	attackpct[iter.imeff->aff_unit] = attackpct[iter.imeff->aff_unit]
+	  				  * amount / 100;
+	break;
+      case EFT_UNIT_ATTACK_FIREPOWER:
+	attackfppct[iter.imeff->aff_unit] = attackfppct[iter.imeff->aff_unit]
+	  				    * amount / 100;
+        break;
+      case EFT_UNIT_DEFEND_FIREPOWER:
+	defensefppct[iter.imeff->aff_unit] = defensefppct[iter.imeff->aff_unit]
+	  				     * amount / 100;
+        break;
+      case EFT_UNIT_COST:
+	unit_cost_adj[iter.imeff->aff_unit] += amount;
+	break;
+      case EFT_BUILDING_COST:
+	impr_cost_adj += amount;
+	break;
+      case EFT_UNIT_COST_PCT:
+	unit_cost_pct[iter.imeff->aff_unit] =
+	    unit_cost_pct[iter.imeff->aff_unit] * amount / 100;
+	break;
+      case EFT_BUILDING_COST_PCT:
+	impr_cost_pct = impr_cost_pct * amount / 100;
+	break;
+      case EFT_TAX_BONUS:
+	update_bonus(tax_bonus, amount, &iter, TRUE);
+	break;
+      case EFT_TAX_PCT:
+	update_bonus(tax_pct, amount, &iter, FALSE);
+	break;
+      case EFT_LUXURY_BONUS:
+        luxury_bonus += amount; break;
+      case EFT_LUXURY_PCT:
+        luxury_pct = luxury_pct * amount / 100; break;
+      case EFT_SCIENCE_BONUS:
+	update_bonus(science_bonus, amount, &iter, TRUE);
+	break;
+      case EFT_SCIENCE_PCT:
+	update_bonus(science_pct, amount, &iter, FALSE);
+	break;
+      case EFT_PROD_BONUS:
+        shield_bonus += amount; break;
+      case EFT_PROD_PCT:
+        shield_pct = shield_pct * amount / 100; break;
+      case EFT_POLLU_ADJ:
+        poladj += amount; break;
+      case EFT_POLLU_PCT:
+        polpct = polpct * amount / 100; break;
+      case EFT_POLLU_POP_ADJ:
+        poppoladj += amount; break;
+      case EFT_POLLU_POP_PCT:
+        poppolpct = poppolpct * amount / 100; break;
+      case EFT_POLLU_PROD_ADJ:
+        prodpoladj += amount; break;
+      case EFT_POLLU_PROD_PCT:
+        prodpolpct = prodpolpct * amount / 100; break;
+      case EFT_MAKE_CONTENT_MIL:
+        makecontentmil += amount; break;
+      case EFT_MAKE_CONTENT_MIL_PER:
+        makecontentmilper += amount; break;
+      case EFT_MAKE_CONTENT:
+        makecontent += amount; break;
+      case EFT_MAKE_CONTENT_PCT:
+        makecontentpct = makecontentpct * amount / 100; break;
+      case EFT_MAKE_HAPPY:
+        makehappy += amount; break;
+      case EFT_FORCE_CONTENT:
+        forcecontent += amount; break;
+      case EFT_FORCE_CONTENT_PCT:
+        forcecontentpct = forcecontentpct * amount / 100; break;
+      case EFT_FORCE_HAPPY:
+        forcehappy += amount; break;
+      case EFT_CORRUPT_ADJ:
+	corruptadj += amount; break;
+      case EFT_CORRUPT_PCT:
+	corruptpct = corruptpct * amount / 100; break;
+      case EFT_UPKEEP_FREE:
+        upkeep_free = MAX(upkeep_free,amount); break;
+      case EFT_SIZE_UNLIMIT:
+        size_unlimit = MAX(size_unlimit,amount); break;
+      case EFT_GROWTH_FOOD:
+        growth_food = MAX(growth_food,amount); break;
+      case EFT_ENABLE_SPACE:
+        buildflags |= CITY_ENABLE_SPACE; break;
+      case EFT_ENABLE_NUKE:
+        buildflags |= CITY_ENABLE_NUKE; break;
+      case EFT_NUKE_PROOF:
+        nuke_proof = MAX(nuke_proof,amount); break;
+      case EFT_AIRLIFT:
+        pcity->airlift = TRUE; break;
+      default:
+        break;
+      }
+    }
+  } city_effects_iterate_end;
+
+  pcity->corruptadj = corruptadj;
+  pcity->corruptpct = corruptpct;
+  pcity->buildflags = buildflags;
+  set_city_size_limit(pcity, size_unlimit);
+  pcity->nuke_proof = nuke_proof;
+  pcity->growth_food = growth_food;
+  pcity->upkeep_free = upkeep_free;
+
+  /* Apply the multipliers to the bonuses (such that the bonuses are all
+     summed first, and only then are the multipliers applied) */
+  for (i = 0; i < 4; ++i) {
+    tax_bonus[i] = tax_bonus[i] * tax_pct[i] / 100;
+    science_bonus[i] = science_bonus[i] * science_pct[i] / 100;
+  }
+  shield_bonus = shield_bonus * shield_pct / 100;
+  luxury_bonus = luxury_bonus * luxury_pct / 100;
+  makecontent = makecontent * makecontentpct / 100;
+  forcecontent = forcecontent * forcecontentpct / 100;
+  poladj = poladj * polpct / 100;
+  poppoladj = poppoladj * poppolpct / 100;
+  prodpoladj = prodpoladj * prodpolpct / 100;
+
+  /* Tithes are generated from "content-making" buildings - note that
+     we're choosing to ignore the makecontentpct modifiers here */
+  if (government_has_flag(gov, G_CONVERT_TITHES_TO_MONEY)) {
+    pcity->tithes_bonus = pcity->makecontent + pcity->forcecontent;
+  } else {
+    pcity->tithes_bonus = 0;
+  }
+
+  if (government_has_flag(gov, G_REDUCED_RESEARCH)) {
+    science_bonus[0] /= 2;
+  }
+
+  pcity->tax_bonus = tax_bonus[0];
+  pcity->science_bonus = science_bonus[0];
+  /* FIXME: no handling of Island-range yet */
+  pplayer->tax_bonus = tax_bonus[2];
+  pplayer->science_bonus = science_bonus[2];
+  game.tax_bonus = tax_bonus[3];
+  game.science_bonus = science_bonus[3];
+
+  pcity->shield_bonus = shield_bonus;
+  pcity->shield_prod = pcity->shield_prod * shield_bonus / 100;
+  pcity->makecontent = makecontent;
+  pcity->makehappy = makehappy;
+  pcity->forcecontent = forcecontent;
+  pcity->forcehappy = forcehappy;
+  pcity->makecontentmil = makecontentmil;
+  pcity->makecontentmilper = makecontentmilper;
+  pcity->poladj = poladj;
+  pcity->poppoladj = poppoladj;
+  pcity->prodpoladj = prodpoladj;
+
+  pcity->impr_cost_pct = impr_cost_pct * impr_cost_adj / 100;
+  for (i = 0; i <= UCL_LAST; i++) {
+    pcity->defensepct[i] = defensepct[i];
+    pcity->attackpct[i] = attackpct[i];
+    pcity->attackfppct[i] = attackfppct[i];
+    pcity->defensefppct[i] = defensefppct[i];
+    pcity->unit_cost_pct[i] = unit_cost_pct[i] * unit_cost_adj[i] / 100;
+  }
+}
+
+/**************************************************************************
 ...
 **************************************************************************/
 static void happy_copy(struct city *pcity, int i)
@@ -1763,94 +2101,55 @@
 }
 
 /**************************************************************************
-...
-**************************************************************************/
-static void citizen_happy_buildings(struct city *pcity)
-{
-  struct government *g = get_gov_pcity(pcity);
-  int faces = 0;
-  happy_copy(pcity, 1);
-
-  if (city_got_building(pcity, B_TEMPLE)) {
-    faces += get_temple_power(pcity);
+  Apply the effect on our citizens' happiness of normal buildings
+  (wonder=FALSE) or Wonders (wonder=TRUE); the bonuses used are updated
+  by update_city_bonuses()
+**************************************************************************/
+static void citizen_happy_buildings(struct city *pcity, int wonder)
+{
+  int hi;	/* hi = "Happy Index" */
+  int confaces;	/* Number of people to make content */
+  int hapfaces;	/* Number of people to make happy */
+
+  if (wonder) { 
+    hi = 4;
+    confaces = pcity->forcecontent;
+    hapfaces = pcity->forcehappy;
+  } else {
+    hi = 2;
+    confaces = pcity->makecontent;
+    hapfaces = pcity->makehappy;
   }
-  if (city_got_building(pcity, B_COURTHOUSE) && g->corruption_level == 0) {
-    faces++;
+  happy_copy(pcity, hi - 1);
+
+  /* hapfaces can make content people happy */
+  while (hapfaces > 0 && pcity->ppl_content[hi] > 0) {
+    pcity->ppl_content[hi]--;
+    pcity->ppl_happy[hi]++;
+    hapfaces--;
   }
 
-  if (city_got_building(pcity, B_COLOSSEUM))
-    faces += get_colosseum_power(pcity);
-  if (city_got_effect(pcity, B_CATHEDRAL))
-    faces += get_cathedral_power(pcity);
-  /* make people content (but not happy):
+  /* If any hapfaces left, have them act as confaces */
+  confaces += hapfaces;
+    
+  /* confaces make people content (but not happy):
      get rid of angry first, then make unhappy content. */
-  while (faces > 0 && pcity->ppl_angry[2] > 0) {
-    pcity->ppl_angry[2]--;
-    pcity->ppl_unhappy[2]++;
-    faces--;
-  }
-  while (faces > 0 && pcity->ppl_unhappy[2] > 0) {
-    pcity->ppl_unhappy[2]--;
-    pcity->ppl_content[2]++;
-    faces--;
-  }
-/* no longer hijacking ppl_content[0]; seems no longer to be helpful -- Syela */
-  /* TV doesn't make people happy just content...
-
-     while (faces && pcity->ppl_content[2]) { 
-     pcity->ppl_content[2]--;
-     pcity->ppl_happy[2]++;
-     faces--;
-     }
-
-   */
-}
-
-/**************************************************************************
-...
-**************************************************************************/
-static void citizen_happy_wonders(struct city *pcity)
-{
-  int bonus = 0;
-
-  happy_copy(pcity, 3);
-
-  if (city_affected_by_wonder(pcity, B_HANGING)) {
-    bonus += 1;
-    if (city_got_building(pcity, B_HANGING))
-      bonus += 2;
-    while (bonus > 0 && pcity->ppl_content[4] > 0) {
-      pcity->ppl_content[4]--;
-      pcity->ppl_happy[4]++;
-      bonus--;
-      /* well i'm not sure what to do with the rest, 
-         will let it make unhappy content */
-    }
-  }
-  if (city_affected_by_wonder(pcity, B_BACH))
-    bonus += 2;
-  if (city_affected_by_wonder(pcity, B_CURE))
-    bonus += 1;
-  /* get rid of angry first, then make unhappy content */
-  while (bonus > 0 && pcity->ppl_angry[4] > 0) {
-    pcity->ppl_angry[4]--;
-    pcity->ppl_unhappy[4]++;
-    bonus--;
-  }
-  while (bonus > 0 && pcity->ppl_unhappy[4] > 0) {
-    pcity->ppl_unhappy[4]--;
-    pcity->ppl_content[4]++;
-    bonus--;
-  }
-  if (city_affected_by_wonder(pcity, B_SHAKESPEARE)) {
-    pcity->ppl_content[4] += pcity->ppl_unhappy[4] + pcity->ppl_angry[4];
-    pcity->ppl_unhappy[4] = 0;
-    pcity->ppl_angry[4] = 0;
-  }
-  if (government_has_flag(get_gov_pcity(pcity), G_NO_UNHAPPY_CITIZENS)) {
-    pcity->ppl_content[4] += pcity->ppl_unhappy[4] + pcity->ppl_angry[4];
-    pcity->ppl_unhappy[4] = 0;
-    pcity->ppl_angry[4] = 0;
+  while (confaces > 0 && pcity->ppl_angry[hi] > 0) {
+    pcity->ppl_angry[hi]--;
+    pcity->ppl_unhappy[hi]++;
+    confaces--;
+  }
+  while (confaces > 0 && pcity->ppl_unhappy[hi] > 0) {
+    pcity->ppl_unhappy[hi]--;
+    pcity->ppl_content[hi]++;
+    confaces--;
+  }
+
+  if (wonder
+      && government_has_flag(get_gov_pcity(pcity), G_NO_UNHAPPY_CITIZENS)) {
+    pcity->ppl_content[hi] += pcity->ppl_unhappy[hi] + pcity->ppl_angry[hi];
+    pcity->ppl_unhappy[hi] = 0;
+    pcity->ppl_angry[hi] = 0;
   }
 }
 
@@ -1867,30 +2166,26 @@
   }
 }
 
-
-
 /**************************************************************************
-...
+  Sets the city's pollution, using the modifiers set by
+  update_city_bonuses
 **************************************************************************/
 static void set_pollution(struct city *pcity)
 {
+  int pol, poppol, prodpol, mod;
   struct player *pplayer = city_owner(pcity);
 
-  pcity->pollution = pcity->shield_prod;
-  if (city_got_building(pcity, B_RECYCLING))
-    pcity->pollution /= 3;
-  else if (city_got_building(pcity, B_HYDRO) ||
-	   city_affected_by_wonder(pcity, B_HOOVER) ||
-	   city_got_building(pcity, B_NUCLEAR))
-    pcity->pollution /= 2;
-
-  if (!city_got_building(pcity, B_MASS)) {
-    pcity->pollution += (pcity->size *
-			 num_known_tech_with_flag
-			 (pplayer, TF_POPULATION_POLLUTION_INC)) / 4;
-  }
+  mod = player_knows_techs_with_flag(pplayer, TF_POPULATION_POLLUTION_INC);
+  prodpol = pcity->shield_prod;
+  poppol = pcity->size * mod / 4;
+
+  prodpol = prodpol * pcity->prodpoladj / 100;
+  poppol = poppol * pcity->poppoladj / 100;
+
+  pol = prodpol + poppol;
+  pol = pol * pcity->poladj / 100;
 
-  pcity->pollution = MAX(0, pcity->pollution - 20);
+  pcity->pollution = MAX(0, pol - 20);
 }
 
 /**************************************************************************
@@ -1938,7 +2233,7 @@
 }
 
 /**************************************************************************
-...
+  Evaluate the cost of supporting units, martial law and aggressive units
 **************************************************************************/
 static void city_support(struct city *pcity, 
                          void (*send_unit_info) (struct player *pplayer,
@@ -1946,18 +2241,14 @@
 {
   struct government *g = get_gov_pcity(pcity);
 
-  bool have_police = city_got_effect(pcity, B_POLICE);
-  int variant = improvement_variant(B_WOMENS);
-
   int free_happy = citygov_free_happy(pcity, g);
   int free_shield = citygov_free_shield(pcity, g);
   int free_food = citygov_free_food(pcity, g);
   int free_gold = citygov_free_gold(pcity, g);
 
-  if (variant == 0 && have_police) {
-    /* ??  This does the right thing for normal Republic and Democ -- dwp */
-    free_happy += g->unit_happy_cost_factor;
-  }
+  /* Add total exemption from unhappiness from aggressive
+   * units, makecontentmil (e.g. from Police Station) */
+  free_happy += pcity->makecontentmil;
 
   happy_copy(pcity, 2);
 
